;****************************************************************************
;*
;*                      SciTech OpenGL Switching Library
;*
;*  ========================================================================
;*
;*    The contents of this file are subject to the SciTech MGL Public
;*    License Version 1.0 (the "License"); you may not use this file
;*    except in compliance with the License. You may obtain a copy of
;*    the License at http://www.scitechsoft.com/mgl-license.txt
;*
;*    Software distributed under the License is distributed on an
;*    "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
;*    implied. See the License for the specific language governing
;*    rights and limitations under the License.
;*
;*    The Original Code is Copyright (C) 1991-1998 SciTech Software, Inc.
;*
;*    The Initial Developer of the Original Code is SciTech Software, Inc.
;*    All Rights Reserved.
;*
;*  ========================================================================
;*
;* Language:    NASM
;* Environment: Intel x86
;*
;* Description: OpenGL stub functions to call dynamically linked OpenGL
;*              code in any version of OpenGL on the system.
;*
;****************************************************************************

include "scitech.mac"           ; Memory model macros

BEGIN_IMPORTS_DEF   _GLS_glsFuncs

; GDI32 functions
DECLARE_STDCALL glsChoosePixelFormat,8
DECLARE_STDCALL glsDescribePixelFormat,16
DECLARE_STDCALL glsGetPixelFormat,4
DECLARE_STDCALL glsSetPixelFormat,12
DECLARE_STDCALL glsSwapBuffers,4

; OpenGL gls functions
DECLARE_STDCALL glsCreateContext,4
DECLARE_STDCALL glsDeleteContext,4
DECLARE_STDCALL glsGetCurrentContext,0
DECLARE_STDCALL glsGetCurrentDC,0
DECLARE_STDCALL glsGetProcAddress,4
DECLARE_STDCALL glsMakeCurrent,8
DECLARE_STDCALL glsShareLists,8
DECLARE_STDCALL glsUseFontBitmapsA,16
DECLARE_STDCALL glsUseFontBitmapsW,16
DECLARE_STDCALL glsUseFontOutlinesA,32
DECLARE_STDCALL glsUseFontOutlinesW,32

END_IMPORTS_DEF

        END                     ; End of module
