/****************************************************************************
*
*                   SciTech Multi-platform Graphics Library
*
*  ========================================================================
*
*    The contents of this file are subject to the SciTech MGL Public
*    License Version 1.0 (the "License"); you may not use this file
*    except in compliance with the License. You may obtain a copy of
*    the License at http://www.scitechsoft.com/mgl-license.txt
*
*    Software distributed under the License is distributed on an
*    "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
*    implied. See the License for the specific language governing
*    rights and limitations under the License.
*
*    The Original Code is Copyright (C) 1991-1998 SciTech Software, Inc.
*
*    The Initial Developer of the Original Code is SciTech Software, Inc.
*    All Rights Reserved.
*
*  ========================================================================
*
* Language:     ANSI C
* Environment:  Any
*
* Description:  Common 256 color palette for all 8 bit display drivers.
*               This palette is the default IBM 256 color palette.
*
****************************************************************************/

#include "mgl.h"
#include "drivers/common/common.h"

/*------------------------- Global Variables ------------------------------*/

palette_t _VARAPI _VGA4_defPal[16] = {
    {0x00,0x00,0x00,0}, {0xA8,0x00,0x00,0}, {0x00,0xA8,0x00,0}, {0xA8,0xA8,0x00,0},
    {0x00,0x00,0xA8,0}, {0xA8,0x00,0xA8,0}, {0x00,0x54,0xA8,0}, {0xA8,0xA8,0xA8,0},
    {0x54,0x54,0x54,0}, {0xFC,0x54,0x54,0}, {0x54,0xFC,0x54,0}, {0xFC,0xFC,0x54,0},
    {0x54,0x54,0xFC,0}, {0xFC,0x54,0xFC,0}, {0x54,0xFC,0xFC,0}, {0xFC,0xFC,0xFC,0},
    };

palette_t _VARAPI _VGA8_defPal[256] = {
    {0x00,0x00,0x00,0}, {0xA8,0x00,0x00,0}, {0x00,0xA8,0x00,0}, {0xA8,0xA8,0x00,0},
    {0x00,0x00,0xA8,0}, {0xA8,0x00,0xA8,0}, {0x00,0x54,0xA8,0}, {0xA8,0xA8,0xA8,0},
    {0x54,0x54,0x54,0}, {0xFC,0x54,0x54,0}, {0x54,0xFC,0x54,0}, {0xFC,0xFC,0x54,0},
    {0x54,0x54,0xFC,0}, {0xFC,0x54,0xFC,0}, {0x54,0xFC,0xFC,0}, {0xFC,0xFC,0xFC,0},
    {0x00,0x00,0x00,0}, {0x14,0x14,0x14,0}, {0x20,0x20,0x20,0}, {0x2C,0x2C,0x2C,0},
    {0x38,0x38,0x38,0}, {0x44,0x44,0x44,0}, {0x50,0x50,0x50,0}, {0x60,0x60,0x60,0},
    {0x70,0x70,0x70,0}, {0x80,0x80,0x80,0}, {0x90,0x90,0x90,0}, {0xA0,0xA0,0xA0,0},
    {0xB4,0xB4,0xB4,0}, {0xC8,0xC8,0xC8,0}, {0xE0,0xE0,0xE0,0}, {0xFC,0xFC,0xFC,0},
    {0xFC,0x00,0x00,0}, {0xFC,0x00,0x40,0}, {0xFC,0x00,0x7C,0}, {0xFC,0x00,0xBC,0},
    {0xFC,0x00,0xFC,0}, {0xBC,0x00,0xFC,0}, {0x7C,0x00,0xFC,0}, {0x40,0x00,0xFC,0},
    {0x00,0x00,0xFC,0}, {0x00,0x40,0xFC,0}, {0x00,0x7C,0xFC,0}, {0x00,0xBC,0xFC,0},
    {0x00,0xFC,0xFC,0}, {0x00,0xFC,0xBC,0}, {0x00,0xFC,0x7C,0}, {0x00,0xFC,0x40,0},
    {0x00,0xFC,0x00,0}, {0x40,0xFC,0x00,0}, {0x7C,0xFC,0x00,0}, {0xBC,0xFC,0x00,0},
    {0xFC,0xFC,0x00,0}, {0xFC,0xBC,0x00,0}, {0xFC,0x7C,0x00,0}, {0xFC,0x40,0x00,0},
    {0xFC,0x7C,0x7C,0}, {0xFC,0x7C,0x9C,0}, {0xFC,0x7C,0xBC,0}, {0xFC,0x7C,0xDC,0},
    {0xFC,0x7C,0xFC,0}, {0xDC,0x7C,0xFC,0}, {0xBC,0x7C,0xFC,0}, {0x9C,0x7C,0xFC,0},
    {0x7C,0x7C,0xFC,0}, {0x7C,0x9C,0xFC,0}, {0x7C,0xBC,0xFC,0}, {0x7C,0xDC,0xFC,0},
    {0x7C,0xFC,0xFC,0}, {0x7C,0xFC,0xDC,0}, {0x7C,0xFC,0xBC,0}, {0x7C,0xFC,0x9C,0},
    {0x7C,0xFC,0x7C,0}, {0x9C,0xFC,0x7C,0}, {0xBC,0xFC,0x7C,0}, {0xDC,0xFC,0x7C,0},
    {0xFC,0xFC,0x7C,0}, {0xFC,0xDC,0x7C,0}, {0xFC,0xBC,0x7C,0}, {0xFC,0x9C,0x7C,0},
    {0xFC,0xB4,0xB4,0}, {0xFC,0xB4,0xC4,0}, {0xFC,0xB4,0xD8,0}, {0xFC,0xB4,0xE8,0},
    {0xFC,0xB4,0xFC,0}, {0xE8,0xB4,0xFC,0}, {0xD8,0xB4,0xFC,0}, {0xC4,0xB4,0xFC,0},
    {0xB4,0xB4,0xFC,0}, {0xB4,0xC4,0xFC,0}, {0xB4,0xD8,0xFC,0}, {0xB4,0xE8,0xFC,0},
    {0xB4,0xFC,0xFC,0}, {0xB4,0xFC,0xE8,0}, {0xB4,0xFC,0xD8,0}, {0xB4,0xFC,0xC4,0},
    {0xB4,0xFC,0xB4,0}, {0xC4,0xFC,0xB4,0}, {0xD8,0xFC,0xB4,0}, {0xE8,0xFC,0xB4,0},
    {0xFC,0xFC,0xB4,0}, {0xFC,0xE8,0xB4,0}, {0xFC,0xD8,0xB4,0}, {0xFC,0xC4,0xB4,0},
    {0x70,0x00,0x00,0}, {0x70,0x00,0x1C,0}, {0x70,0x00,0x38,0}, {0x70,0x00,0x54,0},
    {0x70,0x00,0x70,0}, {0x54,0x00,0x70,0}, {0x38,0x00,0x70,0}, {0x1C,0x00,0x70,0},
    {0x00,0x00,0x70,0}, {0x00,0x1C,0x70,0}, {0x00,0x38,0x70,0}, {0x00,0x54,0x70,0},
    {0x00,0x70,0x70,0}, {0x00,0x70,0x54,0}, {0x00,0x70,0x38,0}, {0x00,0x70,0x1C,0},
    {0x00,0x70,0x00,0}, {0x1C,0x70,0x00,0}, {0x38,0x70,0x00,0}, {0x54,0x70,0x00,0},
    {0x70,0x70,0x00,0}, {0x70,0x54,0x00,0}, {0x70,0x38,0x00,0}, {0x70,0x1C,0x00,0},
    {0x70,0x38,0x38,0}, {0x70,0x38,0x44,0}, {0x70,0x38,0x54,0}, {0x70,0x38,0x60,0},
    {0x70,0x38,0x70,0}, {0x60,0x38,0x70,0}, {0x54,0x38,0x70,0}, {0x44,0x38,0x70,0},
    {0x38,0x38,0x70,0}, {0x38,0x44,0x70,0}, {0x38,0x54,0x70,0}, {0x38,0x60,0x70,0},
    {0x38,0x70,0x70,0}, {0x38,0x70,0x60,0}, {0x38,0x70,0x54,0}, {0x38,0x70,0x44,0},
    {0x38,0x70,0x38,0}, {0x44,0x70,0x38,0}, {0x54,0x70,0x38,0}, {0x60,0x70,0x38,0},
    {0x70,0x70,0x38,0}, {0x70,0x60,0x38,0}, {0x70,0x54,0x38,0}, {0x70,0x44,0x38,0},
    {0x70,0x50,0x50,0}, {0x70,0x50,0x58,0}, {0x70,0x50,0x60,0}, {0x70,0x50,0x68,0},
    {0x70,0x50,0x70,0}, {0x68,0x50,0x70,0}, {0x60,0x50,0x70,0}, {0x58,0x50,0x70,0},
    {0x50,0x50,0x70,0}, {0x50,0x58,0x70,0}, {0x50,0x60,0x70,0}, {0x50,0x68,0x70,0},
    {0x50,0x70,0x70,0}, {0x50,0x70,0x68,0}, {0x50,0x70,0x60,0}, {0x50,0x70,0x58,0},
    {0x50,0x70,0x50,0}, {0x58,0x70,0x50,0}, {0x60,0x70,0x50,0}, {0x68,0x70,0x50,0},
    {0x70,0x70,0x50,0}, {0x70,0x68,0x50,0}, {0x70,0x60,0x50,0}, {0x70,0x58,0x50,0},
    {0x40,0x00,0x00,0}, {0x40,0x00,0x10,0}, {0x40,0x00,0x20,0}, {0x40,0x00,0x30,0},
    {0x40,0x00,0x40,0}, {0x30,0x00,0x40,0}, {0x20,0x00,0x40,0}, {0x10,0x00,0x40,0},
    {0x00,0x00,0x40,0}, {0x00,0x10,0x40,0}, {0x00,0x20,0x40,0}, {0x00,0x30,0x40,0},
    {0x00,0x40,0x40,0}, {0x00,0x40,0x30,0}, {0x00,0x40,0x20,0}, {0x00,0x40,0x10,0},
    {0x00,0x40,0x00,0}, {0x10,0x40,0x00,0}, {0x20,0x40,0x00,0}, {0x30,0x40,0x00,0},
    {0x40,0x40,0x00,0}, {0x40,0x30,0x00,0}, {0x40,0x20,0x00,0}, {0x40,0x10,0x00,0},
    {0x40,0x20,0x20,0}, {0x40,0x20,0x28,0}, {0x40,0x20,0x30,0}, {0x40,0x20,0x38,0},
    {0x40,0x20,0x40,0}, {0x38,0x20,0x40,0}, {0x30,0x20,0x40,0}, {0x28,0x20,0x40,0},
    {0x20,0x20,0x40,0}, {0x20,0x28,0x40,0}, {0x20,0x30,0x40,0}, {0x20,0x38,0x40,0},
    {0x20,0x40,0x40,0}, {0x20,0x40,0x38,0}, {0x20,0x40,0x30,0}, {0x20,0x40,0x28,0},
    {0x20,0x40,0x20,0}, {0x28,0x40,0x20,0}, {0x30,0x40,0x20,0}, {0x38,0x40,0x20,0},
    {0x40,0x40,0x20,0}, {0x40,0x38,0x20,0}, {0x40,0x30,0x20,0}, {0x40,0x28,0x20,0},
    {0x40,0x2C,0x2C,0}, {0x40,0x2C,0x30,0}, {0x40,0x2C,0x34,0}, {0x40,0x2C,0x3C,0},
    {0x40,0x2C,0x40,0}, {0x3C,0x2C,0x40,0}, {0x34,0x2C,0x40,0}, {0x30,0x2C,0x40,0},
    {0x2C,0x2C,0x40,0}, {0x2C,0x30,0x40,0}, {0x2C,0x34,0x40,0}, {0x2C,0x3C,0x40,0},
    {0x2C,0x40,0x40,0}, {0x2C,0x40,0x3C,0}, {0x2C,0x40,0x34,0}, {0x2C,0x40,0x30,0},
    {0x2C,0x40,0x2C,0}, {0x30,0x40,0x2C,0}, {0x34,0x40,0x2C,0}, {0x3C,0x40,0x2C,0},
    {0x40,0x40,0x2C,0}, {0x40,0x3C,0x2C,0}, {0x40,0x34,0x2C,0}, {0x40,0x30,0x2C,0},
    {0x54,0x54,0x54,0}, {0xFC,0x54,0x54,0}, {0x54,0xFC,0x54,0}, {0xFC,0xFC,0x54,0},
    {0x54,0x54,0xFC,0}, {0xFC,0x54,0xFC,0}, {0x54,0xFC,0xFC,0}, {0xFC,0xFC,0xFC,0},
    };
