/****************************************************************************
*
*                   SciTech Multi-platform Graphics Library
*
*  ========================================================================
*
*    The contents of this file are subject to the SciTech MGL Public
*    License Version 1.0 (the "License"); you may not use this file
*    except in compliance with the License. You may obtain a copy of
*    the License at http://www.scitechsoft.com/mgl-license.txt
*
*    Software distributed under the License is distributed on an
*    "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
*    implied. See the License for the specific language governing
*    rights and limitations under the License.
*
*    The Original Code is Copyright (C) 1991-1998 SciTech Software, Inc.
*
*    The Initial Developer of the Original Code is SciTech Software, Inc.
*    All Rights Reserved.
*
*  ========================================================================
*
* Language:     ANSI C
* Environment:  Any
*
* Description:  Main Windowed DirectX device driver header file.
*
****************************************************************************/

#ifndef __DRIVERS_WINDOWS_WINDD_H
#define __DRIVERS_WINDOWS_WINDD_H

#include "drivers/common/gnucleus.h"

/*------------------------- Function Prototypes ---------------------------*/

void *  MGLAPI WINDD_createInstance(void);
ibool   MGLAPI WINDD_detect(void *data,int id,int *numModes,modetab availableModes);
void    MGLAPI WINDD_destroyDC(MGLDC *dc);
ibool   MGLAPI WINDD_initDriver(void *data,MGLDC *dc,modeent *mode,ulong hwnd,int virtualX,int virtualY,int numBuffers,ibool stereo,int refreshRate,ibool useLinearBlits);
void    MGLAPI WINDD_destroyInstance(void *data);

#endif  /* __DRIVERS_WINDOWS_WINDD_H */

